## 1. OVERVIEW

[ Menjelaskan overview modul/fitur yang ada di dalam issue ]


## 2. REQUIREMENT ANALYSIS

[ Menggambarkan kebutuhan fungsional dan bisnis dari Aplikasi yang di harapkan. Dalam bagian ini harus ada komponen sebagai berikut : 

### 2.1 Constraint dari kebutuhan

[ 

Menjelaskan hal-hal khusus yang berkaitan dengan kebutuhan yang diminta. Hal-hal ini bisa berupa kondisi-kondisi tertentu yang mempengaruhi proses dan hasil yang diharapkan dalam aplikasi. 

Misal constraint yang di tulis adalah :
- Input data harus dilakukan pada rentang waktu tertentu
- Pemilihan harga disesuaikan dengan lokasi transaksi 
- Tidak boleh melakukan order yang sama dalam rentang waktu dibawah 2 menit.
- Perubahan task status ke COMPLETED hanya bisa dilakukan oleh leader nya
- Setiap Task harus memiliki bobot dan jumlah bobot dari semua task yang dikerjakan USER tidak boleh lebih dari 100.
- Task hanya bisa di delegasikan kepada team 
- 1 task bisa di delegasikan ke pada lebih dari 1 orang dengan pembobotan bervariasi.
- Dll, 

]

### 2.2 Actor
 
[

Menjelaskan aktor yang terlibat dalam kebutuhan ini, termasuk jika ada kebutuhan integrasi dengan sistem lain maka sistem tersebut juga digambarkan sebagai aktor.

Yang termasuk dalam kategori aktor adalah 
- Pengguna atau kelompok pengguna
- System/Aplikasi lain.

Misal didefiniskan aktor untuk kebutuhan FRXXX adalah :

- Aktor 1
- Aktor 2
- Aktor N

]

### 2.3 UAM/UAR

[ Menjelaskan mapping antara fungsi dan aktor, aktor A bisa melakukan fungsi apa dan dalam kondisi apa. ]


### 2.4 Document

[ Link dokumen drive tempat req ini di tulis dan langsung menuju section yang sesuai. ]

]


## 3. ANALYSIS AND DESIGN

[

Menjelaskan tahapan design dari kebutuhan fungsi dengan menggambarkan Class diagram/ ER , UI/ UX bisa berupa sketch dan sequence diagram atau flow yang bisa menggambarkan kebutuhan dengan jelas.

Dalam tahapan ini di jelaskan juga menggunakan library apa dari NAF dan atau library external apa yang harus di pakai. 

]

### 3.1 Class Diagram 

[ 

Karena sudah object oriented maka penggunaan class diagram lebih tepat untuk menggambarkan object - object apa yang harus di buat. Jika diperlukan bisa menambahkan ER untuk memudahakan.

]

### 3.2 Sequence Diagram 

[ Dari Class diagram bisa digambarkan sequence yang mengambarkan alur proses antar object ]


### 3.3 Document

[ Link dokumen hasil dari proses analysis design ]


### 3.4 Test Case

[ Membuat test case yang berupa unit test dengan phpUnit dan bisnis use case dari segala kombinasi yang mungkin ]

| No | Test Scenario | Test Case | Test Type | Expected Result | Actual Result | Status | Remark |
| ------ | ------ | ------ | ------ | ------ | ------ | ------ | ------ |
| 1 | Diisi dengan Modul / Menu / Fitur | Diisi dengan Item Test | **Positif / Negatif** | Diisi dengan hasil yang diharapkan | Diisi dengan hasil real dari test | **Passed / Failed** | Diisi dengan catatan jika ada |
| 2 |  |  |  |  |  |  |  |
| 3 |  |  |  |  |  |  |  |

### 3.5 Library

[ Info library apa dari NAF dan atau library external apa yang harus di pakai ]
 

## 4. CODE REVIEW

[ Melakukan code review dari proses development. Lampirkan hasil Code Review yang dilakukan oleh SA ]

### CoR1

* [ ] CoR1 - Code Standard - **MANDATORY**
* [ ] CoR2 - Hardcoded Variable - **MANDATORY**
* [ ] CoR3 - Input Sanitation and Validation - OPTIONAL
* [ ] CoR4 - Variable Casting - OPTIONAL
* [ ] CoR5 - Session Security - OPTIONAL
* [ ] CoR6 - Error Handling - OPTIONAL
* [ ] CoR7 - Strong Password - OPTIONAL
* [ ] CoR8 - Standard SQL Builder - **MANDATORY**
* [ ] CoR9 - Input and Output Encryption - OPTIONAL
* [ ] CoR10 - Logging Critical Transaction - OPTIONAL
* [ ] CoR11 - Captcha And One Time Password - OPTIONAL
* [ ] CoR12 - Critical Input Always From Backend - OPTIONAL
* [ ] CoR13 - Acceptable Logic - OPTIONAL
* [ ] CoR14 - Tuning / Optimasi Query - OPTIONAL
* [ ] CoR15 - Sonarqube Scan - **MANDATORY**
* [ ] CoR16 - Owasp Scan - OPTIONAL

### Additional Remark for CoR1


## 5. TESTING

[ 

Tester/SA melakukan pengujian secara menyeluruh berdasarkan dengan dokumen test case yang sudah di buat.

Lampirkan link : 
- PHPUnit
- Test Report Document (dibuat oleh TW)

]


## 6. DEPLOYMENT 
[ Penjelasan rancangan release plan. Lampirkan link :

- Release Notes 
- Transfer Knowledge Document
]

## 7. Tasklist

[ Berikut Task list yang perlu ada untuk meng close kan issue ]
