<?php
namespace Neuron\Person\Controller\Widget;

use Neuron\Access\Session;
Use Neuron\Actor;
use Neuron\Person\Map;

class Person extends \Neuron\Person\Controller {

	public function onDispatch(\Zend\Mvc\MvcEvent $e) {

		$d = parent::onDispatch($e);  //INI HARUS DIPANGGIL!!!!
		$this->layout()->setTemplate('neuron/person/layout/blank');

		$this->getSession();

		return $d;
	}

	protected function getViewPartial($name, $variables = array()) {
		$prefix = 'neuron/person/widget';

		$config = $this->getConfig();
		if (isset($config['person'])) {
			$config = $config['person'];
			$prefix = isset($config['viewprefix']) ? $config['viewprefix'] : $prefix;
		}

		$view = new \Zend\View\Model\ViewModel($variables);
		$view->setTemplate($prefix . '/' . strtolower($name)); // path to phtml file under view folder
		return $view;
	}

	public function DetailAction() {
		
		$empID = $this->params()->fromQuery('id');
		return $this->getViewPartial('detail-layout', get_defined_vars());
	}
	public function profileAction(){
		$request = $this->getRequest();
		$post = $request->getPost();
		
		$languages = new Actor\User\Languages($this->getActorConfig('user'));
		$languages->load();
		$dataLanguages= $languages->pull();

		$storage = \Neuron\Person\Entity\Storage::factory($this->getDb(), $this->getConfig());
		$m_person = new \Neuron\Person\Entity($storage);

		$dataEmployee = $m_person->loadMap($post['id'],'person_id');
		$datauser  = $dataEmployee['data'];
		$dataactor = null;
		if(class_exists('Neuron\Actor\Controller\User') && $datauser['user_id']){	
			$user = new \Neuron\Actor\User(
                \Neuron\Actor\User\Storage::factory(
                    $this->getDb(),
                    $this->getConfig()
                )
            );
			$result = $user->load($datauser['user_id'], 0, null);
			$dataactor = $user->pull();
		}
		// print_r($dataactor); die();
		if(class_exists('Neuron\Document\Entity')){
			$config = $this->getConfig()['upload_document'];
			if(isset($sessmgt['ref_id'])){
				$config['location'] = $config['location'] . '/' . $sessmgt['ref_id'];
			}

			$var = 'uploader_document';
			$this->using('plupload',27);
			$upload = new \Neuron\Upload\Upload($var, $config);
		}else{
			$var = null;
			$upload = null;
		}


		// cari user yang punya profilenya bro
		$empId 			= $post['id'];
		$map 			= new Map(Map\Storage::factory($this->getDb(),$this->getConfig()));
		$map->load($empId,Map\Storage::LOADBY_PERSON_ID);
		$profileUser 	= $map->pull();

		$sessmgt = $this->getSession()->get();
		$userPerson = $this->getUserPerson($sessmgt['code']);
		// print_r($sessmgt); die();
		$editDoc = false;

		if($sessmgt['owned_roles']){
			foreach($sessmgt['owned_roles'] as $role){
				if($role['code'] == 'admin' || $role['code'] == 'HRD'){
					$editDoc = true;
					break;
				}else{
					$editDoc = false;
				}
			}
		}else{
			$editDoc = false;
		}

		$isOwner 		= false;
		$sessOwner 		= $this->getSession()->owner();
		$map 			= $this->getMapPerson($sessOwner);
		if(isset($map['detail']['person_id'])){
			$person_id 	= $map['detail']['person_id'];
			if($person_id == $post['id']){
				$isOwner 	= true;
			} 
		}
		
		$empID = $post['id'];
		if(class_exists('Neuron\Utility\Security\Csrf')) $token = \Neuron\Utility\Security\Csrf::tokenize(NULL, 'token', 16, $this);
		return $this->getViewPartial('profile', get_defined_vars());
	}
	public function CvAction(){
		$empID = $this->params()->fromQuery('id');

		$sessmgt = $this->getSession()->get();
		$userPerson = $this->getUserPerson($sessmgt['code']);
		// print_r($sessmgt); die();
		$invalid = false;
		if(isset($userPerson['person']['ref_id']) && $userPerson['person']['ref_id'] != $empID){
			if($sessmgt['owned_roles']){
				foreach($sessmgt['owned_roles'] as $role){
					if($role['code'] == 'admin' || $role['code'] == 'HRD'){
						$invalid = false;
						break;
					}else{
						$invalid = true;
					}
				}
			}else{
				$invalid = true;
			}
		}
		if(!$invalid){
			//jika ada access

			//EDUCATION
			$addEdu =true;
			$editEdu = true;
			$removeEdu =true;
	
			//EXPERIENCE
			$addExp = true;
			$editExp = true;
			$removeExp = true;
		}else{
			//jika ada access
			
			//EDUCATION
			$addEdu =false;
			$editEdu = false;
			$removeEdu =false;
	
			//EXPERIENCE
			$addExp = false;
			$editExp = false;
			$removeExp = false;
		}
		// print_r($addEdu); die();
		return $this->getViewPartial('cv', get_defined_vars());
	}
	
	public function CvSkillsAction(){
		return $this->getViewPartial('cv-skills', get_defined_vars());
	}
	public function CvCertificationAction(){
		return $this->getViewPartial('cv-certification', get_defined_vars());
	}

	public function ContactAction() {
		$empID = $this->params()->fromQuery('id');

		return $this->getViewPartial('contact', get_defined_vars());
	}

	public function FamilyAction() {
		$empID = $this->params()->fromQuery('id');

		return $this->getViewPartial('family', get_defined_vars());
	}
	public function MedicalAction() {
		$empID = $this->params()->fromQuery('id');

		return $this->getViewPartial('medical', get_defined_vars());
	}

	public function PositionDutiesAction() {
		$empID = $this->params()->fromQuery('id');

		return $this->getViewPartial('position-duties', get_defined_vars());
	}

	//tambahan eri [BEGIN]
	public function PositionShiftAction() {
		$empID = $this->params()->fromQuery('id');

		return $this->getViewPartial('position-shift', get_defined_vars());
	}

	public function EtcAction() {
		$empID = $this->params()->fromQuery('id');

		return $this->getViewPartial('etc', get_defined_vars());
	}
	//tambahan eri [END]

	public function SalaryAction() {
		$empID = $this->params()->fromQuery('id');

		return $this->getViewPartial('salary', get_defined_vars());
	}

	public function TaxAction() {
		$request = $this->getRequest();
		$post = $request->getPost();
		$empID = $post['id'];

		

		return $this->getViewPartial('tax', get_defined_vars());
	}

	public function ProfileConfigAction(){
		$empID = $this->params()->fromQuery('id');
		$this->getSession();
		$title = $this->translate("Profile Configuration");
		return $this->getViewPartial('profile-config', get_defined_vars());
	}
}