<?php

namespace Neuron\Person\Relation\Status\Storage;

use Neuron\Person\Relation\Status\Storage;

class Mysql extends \Neuron\Db\Storage implements Skeleton {

	public function loadList($ids = null, $mode = Storage::LIST_ALL, $params = null){
        /* base select */
        $select = $this->select()
            ->from(['s' => $this->_tables['person_relation_status']]);
        /* loadby page */
        if ($mode === Storage::LISTBY_PAGE) {
            /* get pager */
            $pager = Pager::sanitize($params);
            $select->limit($pager->getLimit())->offset($pager->getOffset())->cache(0);

            /* has keyword? */
            if (!empty($ids)) {
                $select->where->nest()
                    ->like($this->_('model_id', 'a.'), '%' . trim($ids) . '%')
                    ->or
                    ->like($this->_('name', 'a.'), '%' . trim($ids) . '%')
                    ->or
                    ->like($this->_('description', 'a.'), '%' . trim($ids) . '%')
                    ->unnest();
            }
        } else {
            $pager = new \Neuron\Db\Storage\Pager(1, 999999);
        }

        try {
            $rows = $this->fetchAll($select);
            $result = new \stdClass();
            $result->list = $rows;
            $result->pager = $pager;
            $total = isset($rows->total) ? $rows->total : 0;
            $result->countTotal = $total;
            return $result;
        } catch (\Throwable $ex) {
            error_log('Error at ' . $ex->getFile() . ' line ' . $ex->getLine() . ': ' . $ex->getMessage());
            return false;
        }
    }

}